<template>
  <b-button
    variant="primary"
    v-b-modal.update-test-modal
    v-show="me && me.groups.includes('MOD')"
  >
    <b-icon-pencil />
    Edit

    <b-modal id="update-test-modal" :title="`Update ${test.name}`" @ok="submit">
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="name">Name</label>
        <b-form-input
          id="name"
          v-model="name"
          :state="name.length >= 1"
          placeholder="Test name"
          trim
        />

        <label for="description">Description</label>
        <b-form-textarea
          id="description"
          v-model="description"
          placeholder="Describe your test in a few words..."
          trim
        />

        <label for="group">Group</label>
        <b-form-input id="group" v-model="group" trim />

        <label for="steps">Steps</label>
        <b-form-textarea
          id="steps"
          v-model="steps"
          placeholder="Give the testers detailed instructions..."
          trim
        />

        <label for="weight">Weight</label>
        <b-form-select
          id="weight"
          v-model="weight"
          :options="['CRITICAL', 'HIGH', 'MEDIUM', 'LOW']"
        />
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "UpdateSystem",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: this.test.name || "",
      description: this.test.description || "",
      group: this.test.group || "default",
      steps: this.test.steps || "",
      weight: this.test.weight || "MEDIUM"
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    test: Object
  },
  methods: {
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($id: ID!, $test: TestInput!) {
              updateTest(id: $id, test: $test) {
                id
              }
            }
          `,
          variables: {
            id: this.test.id,
            test: {
              name: this.name || undefined,
              description: this.description || undefined,
              group: this.group || "default",
              steps: this.steps || undefined,
              weight: this.weight || "MEDIUM"
            }
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
